%% Exercise 4, Sheet 3
%% LOAD IMAGES

I1 = double(imread('MPEG7/bat-9.gif'));
I2 = double(imread('MPEG7/device7-1.gif'));
I3 = double(imread('MPEG7/turtle-1.gif'));

samples = 300;

C1 = extract_pointwise_contour(I1, samples);
C2 = extract_pointwise_contour(I2, samples);
C3 = extract_pointwise_contour(I3, samples);

%% a, integral invariant

kernel_size = 200; % 10, 32, 100, 200 
gauss_std_dev = 100; % 3, 10, 30, 100

kernel = fspecial('gauss', kernel_size, gauss_std_dev);

II1 = conv2(I1, kernel, 'same');
II2 = conv2(I2, kernel, 'same');
II3 = conv2(I3, kernel, 'same');

f1 = pw_feature(II1, C1);
f2 = pw_feature(II2, C2);
f3 = pw_feature(II3, C3);

figure,
plotsize = 30;
subplot(3,3,1), imagesc(kernel), 
subplot(3,3,4), imagesc(II1),
subplot(3,3,5), imagesc(II2),
subplot(3,3,6), imagesc(II3),
subplot(3,3,7), scatter(C1(1,:), -C1(2,:), plotsize*ones(size(f1)), f1, 'filled'), axis equal, axis off,
subplot(3,3,8), scatter(C2(1,:), -C2(2,:), plotsize*ones(size(f2)), f2, 'filled'), axis equal, axis off,
subplot(3,3,9), scatter(C3(1,:), -C3(2,:), plotsize*ones(size(f3)), f3, 'filled'), axis equal, axis off,

%% b, shape context

kernel_radius = 50;

nR = 3;
nA = 10;
Rs = linspace(0, kernel_radius, nR+1);
As = linspace(0, 2*pi, nA+1);

cs = -kernel_radius:1:kernel_radius;
[X, Y] = meshgrid(cs, cs);

angles = atan2(Y, X);
angles = angles - min(min(angles));
radii = sqrt(X.^2 + Y.^2);

figure,

for i = 2:length(Rs)
    for j = 2:length(As)
        subplot(nR,nA,(j-2)*nR+(i-1)),
        kernel = angles < As(j) & angles > As(j-1) & radii < Rs(i) & radii > Rs(i-1);
        SC = conv2(I1, double(kernel), 'same');
        f = pw_feature(SC,C1);
        scatter(C1(1,:), -C1(2,:), plotsize*ones(size(f)), f, 'filled'), axis equal, axis off,
        %imagesc(kernel)
    end
end
