function [ i_inv ] = integral_invariant( I, C, kSize, gauss )
%INTEGRAL_INVARIANT Calculates the integral invariant on each contour
%   point of C with a kernel size 'kSize' and a gauss std dev of 'gauss'.
%   The output is a n x 1 vector.

kernel = fspecial('gauss', kSize, gauss);
II = conv2(I, kernel, 'same');

i_inv = pw_feature(II, C);

end

