function [ shape_context ] = shape_context( I, C, kRadius, nR, nA )
%SHAPE_CONTEXT Summary of this function goes here
%   Detailed explanation goes here

Rs = linspace(0, kRadius, nR+1);
As = linspace(0, 2*pi, nA+1);

cs = -kRadius:1:kRadius;
[X, Y] = meshgrid(cs, cs);

angles = atan2(Y, X);
angles = angles - min(min(angles));
radii = sqrt(X.^2 + Y.^2);

shape_context = zeros(nR*nA, size(C,2));

for i = 2:length(Rs)
    for j = 2:length(As)
        kernel = angles < As(j) & angles > As(j-1) & radii < Rs(i) & radii > Rs(i-1);
        SC = conv2(I, double(kernel), 'same');
        shape_context((j-2)*nR+(i-1), :) = pw_feature(SC,C);
    end
end

end

