function [ A ] = vertex_voronoi( M )
%VERTEX_MASS Calculates the voronoi mass at each vertex.
% Assumes the areas of each triangle to be given in M.areas.

num_vertices = size(M.VERT, 1);
faces = M.TRIV;

% compute area of Voronoi cells
A = zeros(num_vertices,1);
for j = 1:num_vertices
    for i = 1:3
        ind_j = find(faces(:,i) == j);
        for l = 1:size(ind_j,1)
            face_index = ind_j(l);
            A(j) = A(j) + M.areas(face_index)/3;
        end        
    end
end

end

